//VOLS$    JOB (SYS),'INSTALL VOLS',CLASS=S,MSGCLASS=X                  00010000
//*                                                                     00010200
//* SOURCE: CBT (V490) FILE #360                                        00010300
//* TARGET: SYS2.CMDLIB   SYS2.HELP                                     00010400
//*                                                                     00010500
//********************************************************************* 00010600
//* This job installs the VOLS TSO command (modified to add 3340,     * 00010700
//* 3375, and 3390 DASD types, and help.                              * 00010800
//********************************************************************* 00011100
//*                                                                     00011200
//INSTALL PROC SOUT='*',               <=== SYSOUT CLASS                00011300
//             LIB='SYS2.CMDLIB',      <=== TARGET LOAD LIBRARY         00011400
//             HELP='SYS2.HELP',       <=== HELP LIBRARY                00011500
//             SYSTS=SYSDA,            <=== UNITNAME FOR WORK DATASETS  00011600
//             ASMBLR=IFOX00,          <=== NAME OF YOUR ASSEMBLER      00011700
//             ALIB='SYS1.LINKLIB',    <=== LOCATION OF YOUR ASSEMBLER  00011800
//             MACLIB='SYS1.MACLIB',   <=== MACLIB DATASET NAME         00011900
//             AMODGEN='SYS1.AMODGEN'  <=== AMODGEN DATASET NAME        00012000
//*                                                                     00012100
//IEBUPDTE EXEC PGM=IEBUPDTE,PARM=NEW                                   00012200
//SYSPRINT DD  SYSOUT=&SOUT                                             00012300
//SYSUT1   DD  DSN=&HELP,DISP=SHR                                       00012400
//SYSUT2   DD  DSN=&HELP,DISP=SHR                                       00012500
//*                                                                     00012600
//ASM     EXEC PGM=&ASMBLR,REGION=2048K,PARM='NOOBJECT,DECK,NOALIGN'    00012700
//STEPLIB  DD  DSN=&ALIB,DISP=SHR                                       00012800
//SYSTERM  DD  SYSOUT=&SOUT                                             00012900
//SYSPRINT DD  SYSOUT=&SOUT                                             00013000
//SYSLIB   DD  DSN=&MACLIB,DISP=SHR                                     00013100
//         DD  DSN=&AMODGEN,DISP=SHR                                    00013200
//SYSUT1   DD  UNIT=&SYSTS,SPACE=(TRK,(30,15))                          00013300
//SYSUT2   DD  UNIT=&SYSTS,SPACE=(TRK,(30,15))                          00013400
//SYSUT3   DD  UNIT=&SYSTS,SPACE=(TRK,(30,15))                          00013500
//SYSPUNCH DD  DSN=&&SYSLIN,UNIT=&SYSTS,DISP=(,PASS,DELETE),            00013600
//             SPACE=(TRK,(10,1),RLSE)                                  00013700
//*                                                                     00013800
//LKED    EXEC PGM=IEWL,COND=(0,NE),PARM='LIST,MAP,XREF'                00013900
//SYSPRINT DD  SYSOUT=&SOUT                                             00014000
//SYSUT1   DD  UNIT=&SYSTS,SPACE=(TRK,10)                               00014100
//SYSLMOD  DD  DSN=&LIB,DISP=SHR                                        00014200
//SYSLIN   DD  DSN=&&SYSLIN,DISP=(OLD,DELETE)                           00014300
//         DD  DDNAME=SYSIN                                             00014400
//        PEND                                                          00014500
//*                                                                     00014600
//        EXEC INSTALL                                                  00014700
//*                                                                     00014800
//IEBUPDTE.SYSIN DD *                                                   00014900
./ ADD NAME=VOLS                                                        00015000
                                                                        00015100
)F Function -                                                           00015200
                                                                        00015300
       VOLS Will inform the user which DASD volumes are                 00015400
       online and how much freespace there is on each                   00015500
       volume.  VOLS also indicates whether or not the                  00015600
       volumes listed are currently in use, what the                    00015700
       volume attribute is and how many DCBs are                        00015800
       currently open for files on that volume.                         00015900
                                                                        00016000
       Sample output:                                                   00016100
                                                                        00016200
            UNIT TOT FR TOT FR  TOT   LRG. FREE   IN   UNIT  OPEN       00016300
VOLSER DEVT ADDR   CYL    TRK   XTNS  CYLS+TRKS   USE  ATTR  DCBS       00016400
SAMP01 3330  2C0  0003   0021   0004  0003+0000   NO   PRIV     0       00016500
SAMP02 3311  2D4  0130   0678   0077  0006+0013   NO   PRIV     0       00016600
SAMP03 3350  4D0  0179   0112   0013  0059+0000   YES  STOR     5       00016700
SAMP04 3380  4F1  0064   0017   0003  0042+0000   YES  PRIV    21       00016800
                                                                        00016900
**PROCESSING COMPLETED**  ---  VOLS REL.01 MOD.6B                       00017000
)X SYNTAX -                                                             00017100
                                                                        00017200
   VOLS Type('voltype')                                                 00017300
             DEVIcetype   DEVT('devicetype')                            00017400
             Attribute('volattr')                                       00017500
        Volume('volser')   Serial('volser')                             00017600
        Ucbaddr('device-cuu')   Address('device-cuu')                   00017700
        Clear                                                           00017800
                                                                        00017900
        Required - none                                                 00018000
        Default  - TYPE(ALL)                                            00018100
                                                                        00018200
  NOTE: Devicetype, Devt, and Attribute are aliases for Type.           00018300
        Serial is an alias for Volume.                                  00018400
        Address is an alias for Ucbaddr.                                00018500
                                                                        00018600
)O Operands -                                                           00018700
))TYPE       - Specifies selection criteria.                            00018800
               Valid entries for TYPE are:                              00018900
                     All     - select ALL devices -- DEFAULT            00019000
                     PRivate - select PRIVATE devices                   00019100
                     PUblic  - select PUBLIC devices                    00019200
                     Storage - select STORAGE devices                   00019300
                     3390    - select 3390 devices                      00019400
                     3380    - select 3380 devices                      00019500
                     3375    - select 3375 devices                      00019600
                     3350    - select 3350 devices                      00019700
                     3340    - select 3340 devices                      00019800
                     3311    - select 3311 devices                      00019900
                     3330    - select 3330 devices                      00020000
                     2314    - select 2314 devices                      00020100
))DEVICETYPE - Specifies selection criteria - alias for TYPE.           00020200
))DEVT       - Specifies selection criteria - alias for TYPE.           00020300
))ATTRIBUTE  - Specifies selection criteria - alias for TYPE.           00020400
                                                                        00020500
))VOLUME     - Specifies selection by volume serial number.             00020600
               The VOLUME parameter may be a specific volser or         00020700
               some level of volser up to 6 characters in length.       00020800
               If a level is specified all devices that have serial     00020900
               numbers beginning with that level will be displayed.     00021000
))SERIAL     - Specifies selection criteria - alias for VOLUME.         00021100
                                                                        00021200
))UCBADDR    - Specifies selection by the device address.               00021300
               The UCBADDR parameter may be a spedific address or       00021400
               some level of address up to 3 characters in length.      00021500
               if a level is specified all devices that have addresses  00021600
               beginning with that level will be displayed.             00021700
))ADDRESS    - Spedifies selection criteria - alias for UCBADDR.        00021800
                                                                        00021900
))CLEAR      - Clears the screen if executing on a display video and    00022000
               redisplays the headings on the top of all subsequent     00022100
               screens.                                                 00022200
                                                                        00022300
./ ENDUP                                                                00022400
/*                                                                      00022500
//*----------------------------------------------------------- IEBUPDTE 00022600
//*                                                                     00023000
//ASM.SYSIN DD *                                                        00090000
         MACRO
&LABEL   BEGIN &SAVAREA,       * NAME OF SAVE AREA IN PROGRAM          *
               &NAME,          * NAME ON STM INSTRUCTION IF &STMLBL='' *
               &CSECT=YES,       YES - GENERATE CSECT IF NONE FOUND    *
               &TYPE=CSECT,      TYPE OF ENTRY: CSECT OR ENTRY         *
               &BASE=,           UP TO 3 BASE REGS R,(R,R),OR(R,R,R)   *
               &SAVE=,           ADDRESS OR SPECIFICATION OF SAVEAREA  *
               &TITSTMT=YES,     YES - GENERATE A TITLE STATEMENT      *
               &TITLBL=*DFLT,    LABEL FOR TITLE STATEMENT             *
               &TITLE=,          TITLE INFORMATION                     *
               &STMLBL=,         LABEL FOR THE STM STATEMENT           *
               &NOP=NO,          YES - GENERATE NOPR'S FOR ZAPPING     *
               &REQUS=YES,       YES - GENERATE REGISTER EQUATES       *
               &R=R,             CHARACTERS TO PREFIX REGISTER NUMBERS *
               &GEN=NOGEN,       LIST CODE FOR GETMAINING SAVE AREA    *
               &USING13=YES,     YES - INCLUDE USING R13 FOR &SAVAREA  *
               &VER=,            VERSION OF CODE              (4 CHAR) *
               &ID=,           * HAS NO FUNCTION - FOR COMPATIBILITY   *
               &ICATCH=YES,      YES - INCLUDE WSRCC BEGIN EYECATCH    *
               &BUREAU=WSRCC,    BUREAU RESPONSIBLE FOR CODE  (7 CHAR) *
               &SECTION=TECHSUP, SECTION RESPONSIBLE FOR CODE (7 CHAR) *
               &UNIT=SYSSOFT,    UNIT RESPONSIBLE FOR CODE    (7 CHAR) *
               &AUTHOR=***       AUTHOR'S INITIALS            (3 CHAR)
.*
.* ABOVE COMMENTS PRECEEDED BY A ASTERISK ('*') INDICATE PARAMETER
.* IS INCLUDED FOR COMPATIBILITY ONLY AND SHOULD NOT BE USED
.*
.*
         GBLB  &RFLAG
         GBLC  &RLEN,&RSP
         LCLC  &CLABEL,&SCODE,&SREG1,&SREG2,&SLBL,&SAVNAME,&BREG1
         LCLC  &TITLBLC,&TITL,&TITLVER,&VERTEMP
.*
         LCLC  &C,&SPOT,&HDR,&CVAL
.*
.*
.*
         MNOTE *,'***WSRCC REENTRANT BEGIN MACRO V01.01***'
.*                  WITH THANKS TO HEWLETT-PACKARD BAEDP
.*
.*
&CLABEL  SETC  '&SYSECT'
         AIF   ('&CSECT' NE 'YES').CLBL99
&CLABEL SETC   '&LABEL'
         AIF   ('&CLABEL' NE '').CLBL99
&CLABEL  SETC  'PRIVATE'
         MNOTE *,'*** NO LABEL ON BEGIN, &TYPE CALLED ''PRIVATE'' ***'
.CLBL99  ANOP
.*
.*
         AIF    ('&TYPE' NE 'ENTRY').ENT99
&CLABEL  DS    0H
         ENTRY &CLABEL
         AGO   .CST99
.ENT99   ANOP
.*
         AIF   ('&CSECT' NE 'YES').CST99
&CLABEL  CSECT
.CST99   ANOP
.*
.*
.*
&SLBL    SETC  '&STMLBL'
         AIF   ('&SLBL' NE '').S1
&SLBL    SETC  '&NAME'
.S1      ANOP
.*
.*
         USING &CLABEL,&R.15
&C       SETC  'C'
&SPOT    SETC  '&SYSECT'
         AIF   ('&CLABEL' EQ '').LBL99
&SPOT    SETC  '&CLABEL'
         AIF   ('&TYPE' NE 'ENTRY').LBL99
&C       SETC  'E'
.LBL99   ANOP
.*
.*
.*   PAD THE VERSION WITH _'S
&VERTEMP SETC  '____'
         AIF   ('&VER' EQ '').VERNULL
&VERTEMP SETC  '&VER'
         AIF   ('&VER'(1,1) NE '''').NOQUOTE
&VERTEMP SETC  '&VER'(2,K'&VER-2)
.NOQUOTE ANOP
         LCLC  &PADSTG
&PADSTG  SETC  (4)'_'
&PADSTG  SETC  '&VERTEMP'.'&PADSTG'
&VERTEMP SETC  '&PADSTG'(1,4)
.VERNULL ANOP
.*
.*
&HDR     SETC  'CL4''&VERTEMP.'''
.HDR99   ANOP
.*
         AIF   ('&ICATCH' NE 'YES').NOICTCH
         B     *+68
         DC    AL1(64),CL3'ID='
         DC    CL8'&SPOT'
         DC    C'&C',AL3(&SPOT)
         DC    &HDR
         DC    C'_',C'&SYSDATE.@&SYSTIME._'
         DC    CL7'&BUREAU',C'-'
         DC    CL7'&SECTION',C':'
         DC    CL7'&UNIT',C','
         DC    CL3'&AUTHOR',C'.'
.NOICTCH ANOP
&SLBL    STM   &R.14,&R.12,12(&R.13)
.*
         AIF ('&NOP' EQ 'NO').NONOP
         CNOP  0,4
         B     *+20
         DC    CL16'ZAP TO 17FF07FE:'
         NOPR  R15         CAN ZAP TO 17FF ( XR  R15,R15 )
         NOPR  R14         CAN ZAP TO 07FE ( BR  R14     )
.NONOP   ANOP
         DROP  &R.15
.*
.*
&BREG1   SETC  '&BASE(1)'
         AIF   ('&BREG1' NE '').B10
&BREG1   SETC '&R.12'
         MNOTE *,'** NO BASE REGISTER SPECIFIED ASSUME REGISTER 12 **'
.B10     ANOP
         LR    &BREG1,&R.15
         USING &CLABEL,&BREG1
         AIF   ('&BASE(2)' EQ '').B999
         LA    &BASE(2),4095(&BREG1)
         LA    &BASE(2),1(&BASE(2).)
         USING &CLABEL+4096,&BASE(2)
         AIF   ('&BASE(3)' EQ '').B999
         LA    &BASE(3),4095(&BASE(2).)
         LA    &BASE(3),1(&BASE(3).)
         USING &CLABEL+8192,&BASE(3)
.B999    ANOP
.*
         AIF   ('&SAVE' EQ 'NONE').SV99
&SAVNAME SETC  '&SAVE(1)'
&RLEN    SETC  '&SAVE(2)'
&RSP     SETC  '&SAVE(3)'
         AIF   ('&SAVNAME' NE '').SV10
&SAVNAME SETC  '&SAVAREA'
.SV10    ANOP
         AIF   ('&SAVE(1)' NE '' OR '&SAVE(2)'  NE '' OR '&SAVE(3)' NE *
               '').SV20
         AIF   ('&SAVAREA' NE '').SVNRENT
         AGO   .SVRENT
.SV20    ANOP
         AIF   ('&SAVE(2)' EQ '' AND '&SAVE(3)' EQ '').SVNRENT
         AGO   .SVRENT
.*
.*
.SVNRENT ANOP
&RFLAG   SETB  0
         LR    &R.15,&R.13
         LA    &R.13,&SAVNAME
         ST    &R.15,4(&R.13)
         ST    &R.13,8(&R.15)
         AGO   .SV99
.*
.*
.SVRENT  ANOP
&RFLAG   SETB  1
         AIF   ('&RLEN' NE '').SVRSET
&RLEN    SETC  '72'
         MNOTE *,'*** REENTRANT SAVE AREA FORMAT USED ***'
.SVRSET  ANOP
.*
.********* FOLLOWING FIX APPLIED 15 JAN 79 - DP *********************
.* IF &RLEN IS AN 'L'' TYPE CONSTANT, DOUBLE-UP THE QUOTES FOR MNOTE
         GBLC  &RLENA,&RLENB
         LCLA  &LRLEN
&RLENA   SETC  ''
&RLENB   SETC  '&RLEN'
         AIF   ('&RLEN'(1,2) NE 'L''').NORLQ
&RLENA   SETC  'L'''''
&LRLEN   SETA  K'&RLEN-2
&RLENB   SETC  '&RLEN'(3,&LRLEN)
.NORLQ   ANOP
         MNOTE *,'*      GETMAIN R,LV=&RLENA.&RLENB,SP=&RSP'
         PUSH  PRINT
         PRINT &GEN
         GETMAIN R,LV=&RLEN,SP=&RSP
         POP   PRINT
         LR    &R.15,&R.13
         LR    &R.13,&R.1
         ST    &R.15,4(&R.13)
         ST    &R.13,8(&R.15)
         LM    &R.15,&R.1,16(&R.15)    RESET 0, 1, AND 15
         AGO   .SV99
.*
.*
.SV99    ANOP
.*
.*
         AIF   ('&SAVNAME' EQ '').UTH99
         AIF   ('&USING13' NE 'YES').UTH99
         USING &SAVNAME,&R.13
.UTH99   ANOP
.*
         AIF   ('&REQUS' NE 'YES').REQNO
         MNOTE *,'REGISTER NAMES &R.0 THROUGH &R.15 ARE ASSIGNED'
&R.0     EQU   0
&R.1     EQU   1
&R.2     EQU   2
&R.3     EQU   3
&R.4     EQU   4
&R.5     EQU   5
&R.6     EQU   6
&R.7     EQU   7
&R.8     EQU   8
&R.9     EQU   9
&R.10    EQU   10
&R.11    EQU   11
&R.12    EQU   12
&R.13    EQU   13
&R.14    EQU   14
&R.15    EQU   15
.REQNO   ANOP
.*
         AIF   ('&TITSTMT' NE 'YES').TIT99
&TITLBLC SETC  '&CLABEL'
         AIF   ('&TITLBL' EQ '*DFLT').TIT50
&TITLBLC SETC  '&TITLBL'
.TIT50   ANOP
&TITL    SETC  '&TITLE'
         PUSH  PRINT
         PRINT OFF       TITLE STATEMENT FOLLOWS
         AIF   ('&TITLE' NE '').TIT79
&TITL    SETC  ''' '''
         AIF   ('&VER' EQ '').TIT79
&TITLVER SETC  '&VER'
&TITL    SETC  '''VER '.'&TITLVER'.''''
.TIT79   ANOP
         AIF   ('&TITL'(1,1) EQ '''').TIT89
&TITL    SETC  ''''.'&TITL'.''''
.TIT89   ANOP
&TITLBLC TITLE &TITL
         POP   PRINT
.TIT99   ANOP
         MEND
         MACRO
&LABEL   FINISH  &RC=0,                ABSOLUTE OR (R) FOR RETURN CODE *
               &R=,                    PREFIX FOR REGISTERS            *
               &GEN=NOGEN,             GEN - LIST CODE FOR FREEMAIN    *
               &RC1=,                  ABS OR (R) VALUE RETURNED IN R1 *
               &RTRNOFF=,              RETURN OFFSET VALUE             *
               &RETURN=YES             YES - GENERATE CODE FOR RETURN
.*
.*
.*
         GBLB  &RFLAG
         GBLC  &RLEN,&RLENA,&RLENB,&RSP,&CT
         LCLC  &OPCD,&OPC1,&RETCODE,&RETCD1
.*
.*
          AIF   ('&SYSLIST(1)' EQ '').ERR99
          MNOTE 8,'*** PARTIAL REGISTER LIST NO LONGER SUPPORTED IN BEG*
                IN OR FINISH ***'
.ERR99   ANOP
.*
.*
&RETCODE SETC  '&RC(1)'
         AIF   ('&RETCODE' NE '').RC99
&RETCODE SETC  '0'
         MNOTE *,'*** NO RETURN CODE SPECIFIED ** ZERO ASSUMED ***'
.RC99    ANOP
.*
.*
&OPCD    SETC  'LR'
         AIF   ('&RC'(1,1) EQ '(').OP99
&OPCD    SETC  'LA'
.OP99    ANOP
.*
.*
.*
&RETCD1  SETC  '&RC1(1)'
         AIF   ('&RETCD1' EQ '').OP199
.*
.*
&OPC1    SETC  'LR'
         AIF   ('&RC1'(1,1) EQ '(').OP199
&OPC1    SETC  'LA'
.OP199   ANOP
         CNOP  0,4
&LABEL   OI    4(&R.13),X'FF'
         AIF   (NOT &RFLAG).GOHOME
.*
.*
.RENT   ANOP
         AIF   ('&OPCD' NE 'LR').RENT10
         LR    &R.2,&RETCODE
&RETCODE SETC  '&R.2'
.RENT10  ANOP
         AIF   ('&OPC1' NE 'LR').RENT20
         LR    &R.3,&RETCD1
&RETCD1  SETC  '&R.3'
.RENT20  ANOP
         LR    &R.1,&R.13
         L     &R.13,4(&R.13)
         MNOTE *,'*      FREEMAIN R,LV=&RLENA.&RLENB,A=(1),SP=&RSP'
         PUSH  PRINT
         PRINT &GEN
         FREEMAIN R,LV=&RLEN,A=(1),SP=&RSP
         POP   PRINT
         AGO   .COMEND
.*
.*
.*
.GOHOME ANOP
         L     &R.13,4(&R.13)
.COMEND  ANOP
         &OPCD &R.15,&RETCODE
         L     &R.14,12(&R.13)
         AIF   ('&OPC1' EQ '').GH90
         L     &R.0,20(&R.13)
         &OPC1 &R.1,&RETCD1
         LM    &R.2,&R.12,28(&R.13)
         AGO   .GH99
.GH90    ANOP
         LM    &R.0,&R.12,20(&R.13)
.GH99    ANOP
.*
         AIF   ('&RETURN' NE 'YES').RET99
         MVI   12(&R.13),X'FF'
.*
         AIF   ('&RTRNOFF' EQ '').BR14
         B     &RTRNOFF.(&R.14)      TAKE SPECIAL RETURN WITH OFFSET
         AGO   .RET99
.BR14    ANOP
         BR    &R.14
.RET99   ANOP
         MEND
         TITLE 'WSRCC - VOLS TSO C.P.  --  VERSION 6C'              #6C
         PRINT ON,NOGEN
***********************************************************************
*                                                                     *
*  THIS PROGRAM (COMMAND) WILL LIST THE AVAILABLE FREE SPACE ON ALL   *
*  OR SELECTED ONLINE DISK PACKS.  AS IT IS HERE, IT WILL NOT WORK    *
*  UNDER MVS/XA.  THIS CP WAS ORIGIONALLY FROM CAMBRIDAGE SYSTEMS     *
*  GROUP AND WAS DISTRIBUTED IN AN "AS IS" FORM WITH A VERY EARLY     *
*  VERSION OF THE ASM2 PACKAGE.  THIS CP CONTAINED NO COPYRITE NOTICE *
*  IN ANY FORM .  I HAVE RECEIVED PERMISSION FROM CSG TO PUT THIS ON  *
*  THE CBT TAPE.  - J.MARTIN  02/15/85                                *
*                                                                     *
***********************************************************************
         SPACE 1
*--------------MODIFICATION.LOG---------------------------------------*
*                                                                     *
*  PROGRAMMER     DATE     SUMMARY OF CHANGES MADE TO THIS PROGRAM    *
*--------------+--------+---------------------------------------------*
* TOM JARVIS    01/21/80  1. CHANGED CONTROL UNIT NAME CHECK SO THAT  *
*                            ALL DISK VOLUMES ARE LISTED.             *
* JOE MARTIN    03/29/82  2. ADDED THE UNIT ATTR DISPLAY FOR EACH     *
*                            VOLUME. DISPLAY IS STOR, PRIV OR PUBL.   *
*                            ADDED THE BEGIN AND FINISH MACROS.       *
*                            MOVED MOST OF WORKAREA TO DSECT.         *
*                                                                     *
* JOE MARTIN    05/20/82  3. ADDED SOME SELECTION TO THE VOLS COMMAND.*
*                            FORMAT IS "TYPE(....) (DEVT AND ATTR)    *
*                            WHERE THE "...." IS DEVICE TYPE OR       *
*                            OR DEVICE ATTRIBUTE. EXAMPLE:            *
*                            VOLS TYPE(3350) -- SELECT ONLY 3350'S    *
*                            VOLS TYPE(PRIV) -- SELECT PRIVATE VOLS.  *
*                                                                     *
* JOE MARTIN    11/02/82  4. ADDED NUMBER OF OPEN DCB'S TO THE        *
*                            OUTPUT DISPLAY FOR THE VOLS COMMAND.     *
*                                                                     *
* JOE MARTIN    03/21/83  5. ADDED SELECTION FOR VOLSER OR UCB ADDR   *
*                            ADDED PUTLINE SUPPORT REPLACING TPUT.    *
*                            FIXED PROBLEM WITH UCB TABLE LOOKUP RTN. *
*                                                                     *
* JOE MARTIN    03/25/83  6. ADDED CLEAR KEYWORD TO CLEAR THE SCREEN  *
*                            WHEN RUNNING UNDER VTAM.                 *
*                                                                     *
* JAY MOSELEY   10/26/04  6A. ADDED SUPPORT FOR 3390 (LEFT 2314 IN)   *
*                             USING SAM GOLUB'S CHANGES FOR MODEL.    *
*                             INTENDED ONLY FOR USE UNDER MVS 3.8J.   *
*                                                                     *
* JAY MOSELEY   01/18/15  6B. ADDED SUPPORT FOR 3340 AND 3375         *
*                             USING SAM GOLUB'S CHANGES FOR MODEL.    *
*                             INTENDED ONLY FOR USE UNDER MVS 3.8J.   *
* JAY MOSELEY   06/20/23  6C. CORRECT TEST FOR 3340 SELECTION         *
*                                                                     *
*---------------------------------------------------------------------*
         SPACE 2
VOLS     BEGIN SAVE=(SAVEAREA,@SL,17),AUTHOR=CSG,VER=006C           #6C
         SPACE 1
         LR    R11,R1                  POINT AT CPPL.               #3
         USING CPPL,R11
         ST    R11,VOLCPPL             SAVE CPPL ADDRESS            #3
         LA    R7,VIOPL                POINT AT IOPL                #5
         USING IOPL,R7                 SET UP ADDRESSIBILITY - IOPL #5
         LA    R9,VOLPPL               POINT TO PPL                 #3
         USING PPL,R9                  SET UP ADDRESSABILITY TO PPL #3
         L     R10,CPPLPSCB            POINT AT PSCB.               #3
         ST    R10,VOLPSCB             STORE BUFFER ADDRESS IN PPL  #3
         L     R10,CPPLCBUF            COMMAND BUFFER               #3
         ST    R10,PPLCBUF             STORE BUFFER ADDRESS IN PPL  #3
         L     R10,CPPLUPT             USER PROFILE TABLE           #3
         ST    R10,PPLUPT              STORE UPT IN PPL             #3
         ST    R10,IOPLUPT             STORE UPT IN IOPL            #5
         L     R10,CPPLECT             ENVIRONMENT CONTROL TABLE    #3
         ST    R10,PPLECT              STORE ECT IN PPL             #3
         ST    R10,IOPLECT             STORE ECT IN IOPL            #5
         L     R10,VOLPCLP             PARSE CONTROL LIST           #3
         ST    R10,PPLPCL              STORE PCL IN PPL             #3
         LA    R10,VOLECB              EVENT CONTROL BLOCK          #3
         ST    R10,PPLECB              STORE ECB IN PPL             #3
         ST    R10,IOPLECB             STORE ECB IN IOPL            #5
         LA    R10,VOLANS              ANSWER AREA                  #3
         ST    R10,PPLANS              STORE ANSWER ADDRESS IN PPL  #3
         LA    R10,VOLUWA              USER WORK AREA               #3
         ST    R10,PPLUWA              STORE WORK ADDRESS IN PPL    #3
         DROP  R7,R9,R11                                            #6A
         MVI   LINEFLG,C'N'            INITIALIZE DEVICE SELECT FLG #5
         LR    R1,R9                   POINTER TO PPL IN R1         #3
         CALLTSSR EP=IKJPARS           CALL PARSER                  #3
         LTR   R15,R15                 CHECK FOR ZERO PARSE RETURN  #3
         BNZ   FINISH                  GO AWAY UPSET                #3
         L     R8,VOLANS               LOAD ANSWER AREA FOR USING   #3
         USING PCLDSECT,R8             SET UP ADDRESSABILITY TO ANS #3
         MVI   SCRNFLG,C'N'            SET NOT-SCREEN FLAG          #6
         SR    R7,R7                   CLEAR R7 FOR POINTER         #6
         LH    R7,VOLCLEAR             GET POINTER VALUE            #6
         LTR   R7,R7                   IF PARM NOT PRESENT          #6
         BZ    CHKVOLTP                   THEN CONTINUE             #6
         GTSIZE ,                      GET SCREEN DISPLAY SIZE      #6
         LTR   R0,R0                   IF DISPLAY TERMINAL          #6
         BZ    CHKVOLTP                   THEN CONTINUE             #6
         MVI   SCRNFLG,C'Y'            SET SCREEN FLAG              #6
         BCTR  R0,0                    REDUCE FOR THE "***"         #6
         ST    R0,MAXLINES             SAVE SCREEN DISPLAY SIZE     #6
         STFSMODE ON,INITIAL=YES       CLEAR SCREEN                 #6
         STFSMODE OFF                  CLEAR SCREEN                 #6
CHKVOLTP EQU   *
         L     R7,VOLTYPE              POINT AT PARAMETER           #3
         LH    R6,VOLTYPE+4            GET LENGTH OF PARAMETER      #3
         BCTR  R6,0                    REDUCE R6 FOR EX OF CLC      #3
         EX    R6,CLC#ALL              CHECK FOR "ALL"              #3
         BE    SET#ALL                 YES = GO SETUP FOR "ALL"     #3
         EX    R6,CLC#PRIV             CHECK FOR "PRIVATE"          #3
         BE    SET#PRIV                YES = GO SETUP FOR "PRIVATE" #3
         EX    R6,CLC#PUBL             CHECK FOR "PUBLIC"           #3
         BE    SET#PUBL                YES = GO SETUP FOR "PUBLIC"  #3
         EX    R6,CLC#STOR             CHECK FOR "STORAGE"          #3
         BE    SET#STOR                YES = GO SETUP FOR "STORAGE" #3
         EX    R6,CLC#3380             CHECK FOR "3380"             #3
         BE    SET#3380                YES = GO SETUP FOR "3380"    #3
         EX    R6,CLC#3350             CHECK FOR "3350"             #3
         BE    SET#3350                YES = GO SETUP FOR "3350"    #3
         EX    R6,CLC#3330             CHECK FOR "3330"             #3
         BE    SET#3330                YES = GO SETUP FOR "3330"    #3
         EX    R6,CLC#3311             CHECK FOR "3311"             #3
         BE    SET#3311                YES = GO SETUP FOR "3311"    #3
         EX    R6,CLC#2314             CHECK FOR "2314"             #3
         BE    SET#2314                YES = GO SETUP FOR "2314"    #3
         EX    R6,CLC#3390             CHECK FOR "3390"             #6A
         BE    SET#3390                YES = GO SETUP FOR "3390"    #6A
         EX    R6,CLC#3375             CHECK FOR "3375"             #6B
         BE    SET#3375                YES = GO SETUP FOR "3375"    #6B
         EX    R6,CLC#3340             CHECK FOR "3340"             #6B
         BE    SET#3340                YES = GO SETUP FOR "3340"    #6B
         PUTLINE PARM=LINEOUT,OUTPUT=(PBP1,DATA),MF=(E,VIOPL)       #5
         PUTLINE PARM=LINEOUT,OUTPUT=(PBP2,DATA),MF=(E,VIOPL)       #5
*        TPUT  BADPARM1,LBPRM1         TELL USER OF BAD PARM VALUE  #3
*        TPUT  BADPARM2,LBPRM2         TELL USER OF BAD PARM VALUE  #3
         LA    R15,8                   SET RETRUN CODE              #3
         B     FINISH                  GO AWAY WITH NO VOLS OUTPUT  #3
         SPACE
CLC#ALL  CLC   ADALL(0),0(R7)          EXECUTED COMPARE OF PARM.    #3
CLC#PRIV CLC   APRIV(0),0(R7)          EXECUTED COMPARE OF PARM.    #3
CLC#PUBL CLC   APUBL(0),0(R7)          EXECUTED COMPARE OF PARM.    #3
CLC#STOR CLC   ASTOR(0),0(R7)          EXECUTED COMPARE OF PARM.    #3
CLC#3380 CLC   D3380(0),0(R7)          EXECUTED COMPARE OF PARM.    #3
CLC#3350 CLC   D3350(0),0(R7)          EXECUTED COMPARE OF PARM.    #3
CLC#3330 CLC   D3330(0),0(R7)          EXECUTED COMPARE OF PARM.    #3
CLC#3311 CLC   D3311(0),0(R7)          EXECUTED COMPARE OF PARM.    #3
CLC#2314 CLC   D2314(0),0(R7)          EXECUTED COMPARE OF PARM.    #3
CLC#3390 CLC   D3390(0),0(R7)          EXECUTED COMPARE OF PARM.    #6A
CLC#3375 CLC   D3375(0),0(R7)          EXECUTED COMPARE OF PARM.    #6B
CLC#3340 CLC   D3340(0),0(R7)          EXECUTED COMPARE OF PARM.    #6B
         SPACE
SET#ALL  EQU   *                                                    #3
         MVI   SELDEVT,ALLDEVT         SET SELECTION BITS           #6A
         MVI   SELATTR,ALLATTR         SET SELECTION BITS           #6A
         B     TPUTH1                  CONTINUE PROCESSING          #3
SET#PRIV EQU   *                                                    #3
         MVI   SELATTR,ATTRPRIV        SET SELECTION BIT            #6A
         MVI   SELDEVT,ALLDEVT         SET BITS FOR DEVICE TYPES    #6A
         B     TPUTH1                  CONTINUE PROCESSING          #3
SET#PUBL EQU   *                                                    #3
         MVI   SELATTR,ATTRPUBL        SET SELECTION BIT            #6A
         MVI   SELDEVT,ALLDEVT         SET BITS FOR DEVICE TYPES    #6A
         B     TPUTH1                  CONTINUE PROCESSING          #3
SET#STOR EQU   *                                                    #3
         MVI   SELATTR,ATTRSTOR        SET SELECTION BIT            #6A
         MVI   SELDEVT,ALLDEVT         SET BITS FOR DEVICE TYPES    #6A
         B     TPUTH1                  CONTINUE PROCESSING          #3
SET#3380 EQU   *                                                    #3
         MVI   SELDEVT,DEVT3380        SET SELECTION BIT            #6A
         MVI   SELATTR,ALLATTR         SET BITS FOR ALL ATTRIBS     #6A
         B     TPUTH1                  CONTINUE PROCESSING          #3
SET#3350 EQU   *                                                    #3
         MVI   SELDEVT,DEVT3350        SET SELECTION BIT            #6A
         MVI   SELATTR,ALLATTR         SET BITS FOR ALL ATTRIBS     #6A
         B     TPUTH1                  CONTINUE PROCESSING          #3
SET#3330 EQU   *                                                    #3
         MVI   SELDEVT,DEVT3330        SET SELECTION BIT            #6A
         MVI   SELATTR,ALLATTR         SET BITS FOR ALL ATTRIBS     #6A
         B     TPUTH1                  CONTINUE PROCESSING          #3
SET#3311 EQU   *                                                    #3
         MVI   SELDEVT,DEVT3311        SET SELECTION BIT            #6A
         MVI   SELATTR,ALLATTR         SET BITS FOR ALL ATTRIBS     #6A
         B     TPUTH1                  CONTINUE PROCESSING          #3
SET#2314 EQU   *                                                    #3
         MVI   SELDEVT,DEVT2314        SET SELECTION BIT            #6A
         MVI   SELATTR,ALLATTR         SET BITS FOR ALL ATTRIBS     #6A
         B     TPUTH1                  CONTINUE PROCESSING          #3
SET#3390 EQU   *                                                    #6A
         MVI   SELDEVT,DEVT3390        SET SELECTION BIT            #6A
         MVI   SELATTR,ALLATTR         SET BITS FOR ALL ATTRIBS     #6A
         B     TPUTH1                  CONTINUE PROCESSING          #6A
SET#3375 EQU   *                                                    #6B
         MVI   SELDEVT,DEVT3375        SET SELECTION BIT            #6B
         MVI   SELATTR,ALLATTR         SET BITS FOR ALL ATTRIBS     #6B
         B     TPUTH1                  CONTINUE PROCESSING          #6B
SET#3340 EQU   *                                                    #6B
         MVI   SELDEVT,DEVT3340        SET SELECTION BIT            #6B
         MVI   SELATTR,ALLATTR         SET BITS FOR ALL ATTRIBS     #6B
         B     TPUTH1                  CONTINUE PROCESSING          #6B
         EJECT
TPUTH1   EQU   *
         MVI   SERFLG,C'N'         SET VOLSER FLAG                  #5
         L     R6,VOLNAME              POINT AT PARM                #5
         LTR   R6,R6                   IF PARM ADDRESS IS ZERO      #5
         BZ    TPUTH2                     THEN SKIP MOVE OF VOLSER  #5
         LH    R7,VOLNAME+4            GET LENGTH OF PARM           #5
         LTR   R7,R7                   IF LENGTH IS ZERO            #5
         BZ    TPTH2                      THEN SKIP BCTR            #5
         BCTR  R7,0                    REDUCE FOR EX OF CLC         #5
TPTH2    EQU   *
         STH   R7,SERLEN               SAVE SERIAL NUMBER LENGTH    #5
         MVI   SERFLG,C'Y'         SET VOLSER FLAG                  #5
         EX    R7,SERMOVE              MOVE VOLSER TO HOLD AREA     #5
TPUTH2   EQU   *
         MVI   UCBFLG,C'N'             SET UCBADR FLAG              #5
         L     R6,VOLADDR              POINT AT PARM                #5
         LTR   R6,R6                   IF PARM ADDRESS IS ZERO      #5
         BZ    TPUTH3                     THEN SKIP MOVE OF UCBADR  #5
         LH    R7,VOLADDR+4            GET LENGTH OF PARM           #5
         LTR   R7,R7                   IF LENGTH IS ZERO            #5
         BZ    TPTH3                      THEN SKIP BCTR            #5
         BCTR  R7,0                    REDUCE FOR EX OF CLC         #5
TPTH3    EQU   *
         STH   R7,UCBLEN               SAVE UCB ADDRESS LENGTH      #5
         MVI   UCBFLG,C'Y'             SET UCBADR FLAG              #5
         EX    R7,UCBMOVE              MOVE UCBADR TO HOLD AREA     #5
         B     TPUTH3                  SKIP THE EXECUTED STUFF      #5
         SPACE
SERMOVE  MVC   SERVAL(0),0(R6)         MOVE IN VOL SERIAL           #5
UCBMOVE  MVC   UCBVAL(0),0(R6)         MOVE IN UCB ADDRESS          #5
         SPACE
TPUTH3   EQU   *
         SR    R9,R9                   CLEAR OUT LINE COUNTER       #6
         PUTLINE PARM=LINEOUT,OUTPUT=(PLH1,DATA),MF=(E,VIOPL)       #5
         PUTLINE PARM=LINEOUT,OUTPUT=(PLH2,DATA),MF=(E,VIOPL)       #5
         LA    R9,2(0,R9)              INCRIMENT THE LINE COUNTER   #6
         L     R4,16             @ CVT
         L     R2,40(R4)         @ UCB LOOKUP TABLE
         SPACE
UCBLOOP  EQU   *
         LH    R3,0(R2)          GET UCB ADDR.
         SLL   R3,16               MAKE SURE THE UCB ADDR IS
         SRL   R3,16               CLEAN IN THE HIGH ORDER BITS
         LA    R2,2(R2)          BUMP TO NEXT...
         LTR   R3,R3               CHECK FOR NULL
         BZ    UCBLOOP           GET NEXT IF NULL                   #5
         CL    R3,=X'0000FFFF'   END OF TABLE?
         BE    DONE              YES...
         TM    18(R3),X'20'      DISK?
         BZ    UCBLOOP            NO                                #5
         TM    3(R3),X'80'       ONLINE?
         BZ    UCBLOOP            NO                                #5
         TM    6(R3),X'40'       READY? (CHECK NOT READY FLAG)      #5
         BNZ   UCBLOOP            NO    WAS BCR 7,R4                #5
         MVC   LINE(LNGT),BLANKS   MOVE IN BLANKS TO OUTPUT LINE    #2
         MVC   ADDRT(3),13(R3)     MAKE COPY OF CHARACTER UNIT NAME #1
         TR    ADDRT(3),TRTAB      TR ALPHA CHARACTERS A-F TO FA-FF #1
         CLC   ADDRTL,ADDRT        COMPARE UNIT NAMES               #1
         BNL   UCBLOOP             GET NEXT UCB                     #5
CHKVOL   EQU   *
         CLI   SERFLG,C'N'         IF VOL COMPARE NOT NEEDED        #5
         BE    CHKUCB                 THEN CHECK ADDRESS WANTED     #5
         LH    R6,SERLEN           LOAD LENGTH OF SERIAL#-1         #5
         EX    R6,SERCLC           COMPARE SERIAL NUMBER TO UCB     #5
         BNE   UCBLOOP             TRY NEXT VOLSER                  #5
CHKUCB   EQU   *
         CLI   UCBFLG,C'N'         IF UCB COMPARE NOT NEEDED        #5
         BE    SAVE01                 THEN CONTINUE LIKE BEFORE     #5
         LH    R6,UCBLEN           LOAD LENGTH OF UCB ADDRESS       #5
         EX    R6,UCBCLC           COMPARE UCB ACCRESS TO UCB       #5
         BNE   UCBLOOP             TRY NEXT VOLSER                  #5
         B     SAVE01                  CONTINUE AS USUAL            #5
         SPACE
SERCLC   CLC   SERVAL(0),28(R3)        COMPARE REQUESTED VOL - UCB  #5
UCBCLC   CLC   UCBVAL(0),13(R3)        COMPARE REQUESTED ADR - UCB  #5
         SPACE
SAVE01   EQU   *
         MVC   VOLSER(6),28(R3)    MOVE THE VOLSER TO OUTPUT AREA
         MVC   ADDR(3),13(R3)      MOVE THE UNIT ADDRESS TO AREA
         MVC   ADDRTL,ADDRT        KEEP TRANSLATED UNIT NAME        #1
         EJECT
T3380    EQU   *
         CLI   19(R3),X'0E'        IS THIS A 3380
         BNE   T3350               NO GO TRY 3350
         TM    SELDEVT,DEVT3380    CHECK FOR 3380 SELECTION         #6A
         BZ    UCBLOOP             DO NOT CONTINUE IF NO SELECTION  #3
         MVC   DEVT(4),=C'3380'    MOVE THE IN DEVICE TYPE
         B     GOTDEV              GO SETUP FOR OUTPUT
T3350    EQU   *
         CLI   19(R3),X'0B'        IS THIS A 3350
         BNE   T3311               NO GO TRY 3330-1
         TM    SELDEVT,DEVT3350    CHECK FOR 3350 SELECTION         #6A
         BZ    UCBLOOP             DO NOT CONTINUE IF NO SELECTION  #3
         MVC   DEVT(4),=C'3350'    MOVE THE IN DEVICE TYPE
         B     GOTDEV              GO SETUP FOR OUTPUT
T3311    EQU   *
         CLI   19(R3),X'0D'        IS THIS A 3330-1
         BNE   T3330               NO GO TRY 3330
         TM    SELDEVT,DEVT3311    CHECK FOR 3311 SELECTION         #6A
         BZ    UCBLOOP             DO NOT CONTINUE IF NO SELECTION  #3
         MVC   DEVT(4),=C'3311'    MOVE THE IN DEVICE TYPE
         B     GOTDEV              GO SETUP FOR OUTPUT
T3330    EQU   *
         CLI   19(R3),X'09'        IS THIS A 3330
         BNE   T2314               NO GO TRY 2314
         TM    SELDEVT,DEVT3330    CHECK FOR 3330 SELECTION         #6A
         BZ    UCBLOOP             DO NOT CONTINUE IF NO SELECTION  #3
         MVC   DEVT(4),=C'3330'    MOVE THE IN DEVICE TYPE
         B     GOTDEV              GO SETUP FOR OUTPUT
T2314    EQU   *
         CLI   19(R3),X'08'        IS THIS A 2314
         BNE   T3390               NO GO TRY 3390                   #6A
         TM    SELDEVT,DEVT2314    CHECK FOR 2314 SELECTION         #6A
         BZ    UCBLOOP             DO NOT CONTINUE IF NO SELECTION  #3
         MVC   DEVT(4),=C'2314'    MOVE THE IN DEVICE TYPE
         B     GOTDEV              GO SETUP FOR OUTPUT
T3390    EQU   *                                                    #6A
         CLI   19(R3),X'0F'        IS THIS A 3390                   #6A
         BNE   T3375               NO GO TRY 3375                   #6B
         TM    SELDEVT,DEVT3390    CHECK FOR 3390 SELECTION         #6A
         BZ    UCBLOOP             DO NOT CONTINUE IF NO SELECTION  #6A
         MVC   DEVT(4),=C'3390'    MOVE THE IN DEVICE TYPE          #6A
         B     GOTDEV              GO SETUP FOR OUTPUT              #6A
T3375    EQU   *                                                    #6B
         CLI   19(R3),X'0C'        IS THIS A 3375                   #6B
         BNE   T3340               NO GO TRY 3340                   #6B
         TM    SELDEVT,DEVT3375    CHECK FOR 3375 SELECTION         #6B
         BZ    UCBLOOP             DO NOT CONTINUE IF NO SELECTION  #6B
         MVC   DEVT(4),=C'3375'    MOVE THE IN DEVICE TYPE          #6B
         B     GOTDEV              GO SETUP FOR OUTPUT              #6B
T3340    EQU   *                                                    #6B
         CLI   19(R3),X'0A'        IS THIS A 3340                   #6B
         BNE   UNKN                NO GO MOVE IN "UNKN"             #6B
         TM    SELDEVT,DEVT3340    CHECK FOR 3340 SELECTION         #6C
         BZ    UCBLOOP             DO NOT CONTINUE IF NO SELECTION  #6B
         MVC   DEVT(4),=C'3340'    MOVE THE IN DEVICE TYPE          #6B
         B     GOTDEV              GO SETUP FOR OUTPUT              #6B
UNKN     EQU   *
         MVC   DEVT(4),=C'UNKN'    FOUND SOMETHING THAT WE DONT KNOW
GOTDEV   EQU   *
         LR    R0,R3               GOT A GOOD ONE.
         LA    R1,OUTPUT           SETUP FOR LSPCE SVC
         SVC   78                  ISSUE LSPCE
         MVC   ALLC(3),=C'YES'     SET ALLOCATED MSG
         TM    3(R3),X'08'         TEST IF ALLOCATED
         BO    CHKPRIV             BRANCH IF ALLOCATED              #2
         MVC   ALLC(3),=C'NO '     NOT ALLOCATED
CHKPRIV  TM    34(R3),X'10'        IS THIS VOL PRIVATE              #2
         BZ    CHKPUBL             NO -- TRY PUBLIC                 #2
         TM    SELATTR,ATTRPRIV    CHECK FOR PRIV SELECTION         #6A
         BZ    UCBLOOP             DO NOT CONTINUE IF NO SELECTION  #3
         MVC   ATTR(4),=C'PRIV'    MOVE IN PUBLIC LITERAL           #2
         B     MOVESPCE            GO DO SPACE MOVES                #2
CHKPUBL  TM    34(R3),X'08'        IS THIS VOL PUBLIC               #2
         BZ    CHKSTOR             NO -- TRY STORAGE                #2
         TM    SELATTR,ATTRPUBL    CHECK FOR PUBL SELECTION         #6A
         BZ    UCBLOOP             DO NOT CONTINUE IF NO SELECTION  #3
         MVC   ATTR(4),=C'PUBL'    MOVE IN PRIVATE LITERAL          #2
         B     MOVESPCE            GO DO SPACE MOVES                #2
CHKSTOR  TM    34(R3),X'04'        IS THIS VOL PUBLIC               #2
         BZ    CHKFAIL             NO -- INDICATE UNKN              #2
         TM    SELATTR,ATTRSTOR    CHECK FOR STOR SELECTION         #6A
         BZ    UCBLOOP             DO NOT CONTINUE IF NO SELECTION  #3
         MVC   ATTR(4),=C'STOR'    MOVE IN PRIVATE LITERAL          #2
         B     MOVESPCE            GO DO SPACE MOVES                #2
CHKFAIL  MVC   ATTR(4),=C'UNKN'    MOVE IN UNKNOWN LITERAL          #2
MOVESPCE MVC   CYL(4),FCYL         MOVE IN FREE CYLS
         MVC   TRK(4),FTRK         MOVE IN FREE TRKS
         MVC   XTNS(4),NXTN        MOVE IN NUM EXTENTS
         MVC   XCYL(4),OCYL        MOVE IN CONTIG CYLS
         MVC   XTRK(4),OTRK        MOVE IN CONTIG TRKS
         MVI   PLUS,C'+'           MOVE IN THE "+"                  #2
         SR    R5,R5                   CLEAR R5 FOR ICM             #4
         MVC   DCBS,=CL6'     0'       MOVE IN INITIAL DCB COUNT    #4
         ICM   R5,B'0001',35(R3)       INSERT THE DCB COUNT         #4
         BZ    DONEDCB                 GO AWAY                      #4
         SLL   R5,25                   SHIFT LEFT TO REMOVE "MOUNT" #4
         SRL   R5,25                   SHIFT RIGHT TO RESTORE COUNT #4
         CVD   R5,DCBCNT               MAKE DCBCOUNT DECIMAL        #4
         MVC   DCBS(6),DCBEDT          MOVE IN EDIT FIELD           #4
         ED    DCBS(6),DCBCNT+5        PUT IN THE EDITED DCB COUNT  #4
         SPACE
DONEDCB  EQU   *                                                    #4
         CLI   SCRNFLG,C'N'            IF THIS IS NOT-SCREEN MODE   #6
         BE    SHOWLINE                   THEN CONTINUE THIS CODE   #6
         C     R9,MAXLINES             IF LINES EXCEEDED            #6
         BL    SHOWLINE                   THEN DISPLAY HEADING      #6
         SR    R9,R9                   CLEAR OUT LINE COUNTER       #6
         PUTLINE PARM=LINEOUT,OUTPUT=(PLH1,DATA),MF=(E,VIOPL)       #5
         PUTLINE PARM=LINEOUT,OUTPUT=(PLH2,DATA),MF=(E,VIOPL)       #5
         LA    R9,2(0,R9)              INCRIMENT THE LINE COUNTER   #6
SHOWLINE MVC   PLNE(4),PLNELN          MOVE LINE LENGTH FOR PUTLINE #5
         PUTLINE PARM=LINEOUT,OUTPUT=(PLNE,DATA),MF=(E,VIOPL)       #5
         LA    R9,1(0,R9)              INCRIMENT THE LINE COUNTER   #6
         MVI   LINEFLG,C'Y'        SET THE DISPLAYED FLAG           #5
         B     UCBLOOP             GO DO NEXT UCB ENTRY
         SPACE
DONE     EQU   *
         CLI   LINEFLG,C'Y'            IF SOME DEVICES DISPLAYED    #5
         BE    DONE1                      THEN SKIP NODEVICE MSG    #5
         PUTLINE PARM=LINEOUT,OUTPUT=(PLBS,DATA),MF=(E,VIOPL)       #5
         PUTLINE PARM=LINEOUT,OUTPUT=(PLE2,DATA),MF=(E,VIOPL)       #5
         SPACE
DONE1    EQU   *
         PUTLINE PARM=LINEOUT,OUTPUT=(PLBS,DATA),MF=(E,VIOPL)       #5
         PUTLINE PARM=LINEOUT,OUTPUT=(PLE1,DATA),MF=(E,VIOPL)       #5
*        TPUT  BLANKS,1            PUT OUT BLANK LINE               #2
*        TPUT  END1,L'END1         PUT OUT END MESSAGE              #2
         LA    R15,0               SETUP RETURN CODE                #3
         SPACE
FINISH   FINISH RC=(R15)                                            #3
         EJECT
PLH1     DC    AL2(LHDR1+4),AL2(0)     LENGTH FOR PUTLINE           #5
HDR1     DC    C'            UNIT TOT FR TOT FR  TOT   LRG. FREE   IN '
         DC    C'  UNIT  OPEN'                                      #4
LHDR1    EQU   *-HDR1                                               #2
PLH2     DC    AL2(LHDR2+4),AL2(0)     LENGTH FOR PUTLINE           #5
HDR2     DC    C'VOLSER DEVT ADDR   CYL    TRK   XTNS  CYLS+TRKS   USE'
         DC    C'  ATTR  DCBS'                                      #4
LHDR2    EQU   *-HDR2                                               #2
PLE1     DC    AL2(LEND1+4),AL2(0)     LENGTH FOR PUTLINE           #5
END1     DC    C'**PROCESSING COMPLETED**  ---  VOLS REL.01 MOD.6C' #6C
LEND1    EQU   *-END1                                               #5
PLE2     DC    AL2(LEND2+4),AL2(0)     LENGTH FOR PUTLINE           #5
END2     DC    C'  0 DEVICES SELECTED '                             #4
LEND2    EQU   *-END2                                               #5
PLBS     DC    AL2(5),AL2(0)           LENGTH FOR PUTLINE           #5
BLANKS   DC    CL80' '             BLANKS FOR ASSORTED THINGS       #2
PLNELN   DC    AL2(LNGT+4),AL2(0)      LENGTH FOR PUTLINE OF LINE   #5
DCBEDT   DC    XL06'402020202120'  EDIT PATTERN FOR OPEN DCB COUNT  #4
TRTAB    DC    256X'00'            TRANSLATE TABLE                 1.
         ORG   TRTAB+C'A'                                          1.
         DC    X'FAFBFCFDFEFF'                                     1.
         ORG   TRTAB+C'0'                                          1.
         DC    X'F0F1F2F3F4F5F6F7F8F9'                             1.
         ORG
PBP1     DC    AL2(LBPRM1+4),AL2(0)    LENGTH FOR PUTLINE           #5
BADPARM1 DC    C'INVALID SELECTION KEYWORD - '                      #3
LBPRM1   EQU   *-BADPARM1          SETUP LENGTH FOR TPUT            #3
PBP2     DC    AL2(LBPRM2+4),AL2(0)    LENGTH FOR PUTLINE           #5
BADPARM2 DC    C'  VALID ARE: ALL PRIVATE PUBLIC STORAGE '          #3
         DC    C'2314 3330 3311 3340 3350 3375 3380 AND 3390'       #6B
LBPRM2   EQU   *-BADPARM2          SETUP LENGTH FOR TPUT            #3
ADALL    DC    CL8'ALL     '           SELECT ALL VOLUMES           #3
APRIV    DC    CL8'PRIVATE '           ATTRIB IS PRIVATE            #3
APUBL    DC    CL8'PUBLIC  '           ATTRIB IS PUBLIC             #3
ASTOR    DC    CL8'STORAGE '           ATTRIB IS STORAGE            #3
D3380    DC    CL8'3380    '           DEVICE IS 3380               #3
D3350    DC    CL8'3350    '           DEVICE IS 3350               #3
D3330    DC    CL8'3330    '           DEVICE IS 3330               #3
D3311    DC    CL8'3311    '           DEVICE IS 3311               #3
D2314    DC    CL8'2314    '           DEVICE IS 2314               #3
D3390    DC    CL8'3390    '           DEVICE IS 3390               #6A
D3375    DC    CL8'3375    '           DEVICE IS 3375               #6B
D3340    DC    CL8'3340    '           DEVICE IS 3340               #6B
ALLATTR  EQU   X'0F'                   SETUP FOR ALL ATTRIBS        #3
ATTRPRIV EQU   X'04'               SETUP FOR PRIVATE DEVICES        #3
ATTRPUBL EQU   X'02'               SETUP FOR PUBLIC  DEVICES        #3
ATTRSTOR EQU   X'01'               SETUP FOR STORAGE DEIVCES        #3
ALLDEVT  EQU   X'FF'                   SETUP FOR DEVICE TYPES       #3
DEVT2314 EQU   X'01'               SETUP DEVICE TYPE 2314           #3
DEVT3330 EQU   X'02'               SETUP DEVICE TYPE 3330           #3
DEVT3311 EQU   X'04'               SETUP DEVICE TYPE 3311           #3
DEVT3350 EQU   X'08'               SETUP DEVICE TYPE 3350           #3
DEVT3380 EQU   X'10'               SETUP DEVICE TYPE 3380           #3
DEVT3390 EQU   X'20'               SETUP DEVICE TYPE 3390           #6A
DEVT3375 EQU   X'40'               SETUP DEVICE TYPE 3375           #6B
DEVT3340 EQU   X'80'               SETUP DEVICE TYPE 3340           #6B
VOLPCLP  DC    V(PCLCSECT)         POINTER TO PCLCSECT FOR PARSE    #3
         SPACE
         LTORG
         EJECT
WORKAREA DSECT                                                      #2
SAVEAREA DS    18F                     SAVEAREA FOR REGISTERS       #2
SELFLAGS DS    F                       SELECTION FLAGS              #3
SELATTR  EQU   SELFLAGS                                             #6A
SELDEVT  EQU   SELFLAGS+1                                           #6A
VOLCPPL  DS    F                       ADDRESS OF CPPL              #3
VOLPSCB  DS    F                       ADDRESS OF PSCB              #5
VOLECB   DS    F                       ECB FOR PARSE TO USE         #3
VOLANS   DS    F                       ANSWER AREA FOR PARSE        #3
VOLUWA   DS    4F                      USER WORK AREA FOR PARSE     #3
VOLPPL   DS    7F                      PPL FOR USE WITH PARSE       #3
VIOPL    DS    4F                      IOPL FOR PUTLINE SUPPORT     #5
MAXLINES DS    F                       MAX SCREEN SIZE              #6
SCRNFLG  DS    CL1                     DISPLAY SCREEN FLAG          #6
SERLEN   DS    H                       LENGTH OF VOLSER PARM        #5
UCBLEN   DS    H                       LENGTH OF UCBADR PARM        #5
SERFLG   DS    CL1                     FLAG USED TO SELECT VOLSER   #5
UCBFLG   DS    CL1                     FLAG USED TO SELECT UCBADR   #5
SERVAL   DS    CL6                     VALUE OF THE VOLSER PARM     #5
UCBVAL   DS    CL3                     VALUE OF THE UCBADR PARM     #5
LINEFLG  DS    CL1                     DEVICE SELECTED FLAG         #5
TIMEDATE DS    D                       AREA FOR THE TIME AND DATE   #3
DCBCNT   DS    D                       NUMBER OF OPEN DCBS          #4
OUTPUT   DS    0CL30                   LSPACE OUTPUT AREA           #2
         DS    CL6                                                  #2
FCYL     DS    CL4                                                  #2
         DS    CL1                                                  #2
FTRK     DS    CL4                                                  #2
         DS    CL1                                                  #2
NXTN     DS    CL4                                                  #2
         DS    CL1                                                  #2
OCYL     DS    CL4                                                  #2
         DS    CL1                                                  #2
OTRK     DS    CL4                                                  #2
         SPACE 1
         DS    0D                  ALIGNMENT                        #2
PLNE     DS    AL2(LNGT+4),AL2(0)      LENGTH FOR PUTLINE           #5
LINE     EQU   *                                                    #2
VOLSER   DS    CL7' '              VOLUME SERIAL NUMBER             #2
DEVT     DS    CL6' '              DEVICE TYPE                      #2
ADDR     DS    CL5' '              DEVICE ADDRESS                   #2
CYL      DS    CL7' '              FREE CYLS                        #2
TRK      DS    CL7' '              FREE TRKS                        #2
XTNS     DS    CL6' '              EXTENTS                          #2
XCYL     DS    CL4' '              CONTIG CYLS                      #2
PLUS     DS    CL1'+'                                               #2
XTRK     DS    CL7' '              CONTIG TRKS                      #2
ALLC     DS    CL5' '              ALLOCATED FLAG                   #2
ATTR     DS    CL4' '              VOLUME ATTRIBUTES PUBL/PRIV/STOR #2
DCBS     DS    CL6' '              NUMBER OF OPEN DCBS              #4
LNGT     EQU   *-LINE                                               #2
         SPACE 1
ADDRT    DS    CL3                 FIELD TO TRANSLATE UNIT NAME IN 1#2
ADDRTL   DS    CL3                 FIELD TO HOLD TRANS UNIT NAME   1#2
LINEOUT  PUTLINE MF=L              LIST FORMAT OF PUTLINE           #5
@SL      EQU   ((*-SAVEAREA+8/16)*16) LENGTH OF WORKAREA            #2
         EJECT
VOLS     CSECT
         PRINT ON,NOGEN                                             #3
PCLCSECT IKJPARM DSECT=PCLDSECT                                     #3
         SPACE
VOLCLEAR IKJKEYWD ,                                                 #6
         IKJNAME 'CLEAR'                                            #6
         SPACE
VOLPTYPE IKJKEYWD DEFAULT='TYPE'                                    #3
         IKJNAME  'TYPE',SUBFLD=$VOLTYPE                            #3
         IKJNAME  'ATTRIBUTE',SUBFLD=$VOLTYPE                       #3
         IKJNAME  'DEVICETYPE',ALIAS='DEVT',SUBFLD=$VOLTYPE         #3
         SPACE
VOLPNAME IKJKEYWD ,                                                 #5
         IKJNAME  'SERIAL',SUBFLD=$VOLNAME                          #5
         IKJNAME  'VOLSER',SUBFLD=$VOLNAME                          #5
         SPACE
VOLPADDR IKJKEYWD ,                                                 #5
         IKJNAME  'ADDRESS',SUBFLD=$VOLADDR                         #5
         IKJNAME  'UCBNAME',SUBFLD=$VOLADDR                         #5
         SPACE
$VOLTYPE IKJSUBF
VOLTYPE  IKJIDENT 'SELECTION VALUE',UPPERCASE,MAXLNTH=8,            #3 X
               FIRST=ALPHANUM,OTHER=ALPHANUM,                       #3 X
               DEFAULT='ALL',HELP='DASD DEVICE SELECTION VALUE'     #3
         SPACE
$VOLNAME IKJSUBF
VOLNAME  IKJIDENT 'SELECTION VALUE',UPPERCASE,MAXLNTH=6,            #5 X
               FIRST=ALPHANUM,OTHER=ALPHANUM,                       #5 X
               PROMPT='VOLUME SERIAL NUMBER - 6 DIGIT MAX',         #5 X
               HELP='DASD VOLSER SELECTION VALUE'                   #5
         SPACE
$VOLADDR IKJSUBF
VOLADDR  IKJIDENT 'SELECTION VALUE',UPPERCASE,MAXLNTH=3,            #5 X
               FIRST=ALPHANUM,OTHER=ALPHANUM,                       #5 X
               PROMPT='UCB ADDRESS - 3 DIGIT MAX',                  #5 X
               HELP='DASD ADDRESS SELECTION VALUE'                  #5
         SPACE
         IKJENDP
         SPACE
         IKJPPL
         SPACE
         IKJCPPL
         SPACE
         IKJIOPL
         SPACE
         CVT   DSECT=YES
         END
/*
//*----------------------------------------------------------- ASM      09162000
//*                                                                     09163000
//LKED.SYSIN DD *                                                       09180000
  NAME VOLS(R)                                                          09190000
/*                                                                      09191000
//*----------------------------------------------------------- LKED     09192000
//                                                                      09990000

